Index: palm/trunk/INSTALL/ex_lsm_clearsky_rc
===================================================================
--- palm/trunk/INSTALL/ex_lsm_clearsky_rc	(revision 2575)
+++ palm/trunk/INSTALL/ex_lsm_clearsky_rc	(revision 2608)
@@ -1,10 +1,10 @@
 
  ******************************    --------------------------------------------
- * PALM 4.0  Rev: 2532        *    atmosphere - run without 1D - prerun
+ * PALM 4.0  Rev: 2603:26     *    atmosphere - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:                 18-10-17    Run:       ex_lsm_clearsky     
- Time:                 17:42:56    Run-No.:   00
- Run on host:              imuk
+ Date:                 13-11-17    Run:       ex_lsm_clearsky     
+ Time:                 14:31:43    Run-No.:   00
+ Run on host:             lcmuk
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
  ------------------------------------------------------------------------------
@@ -88,7 +88,4 @@
 
     Albedo is set for land surface type: mixed farming, tall grassland
-    Geograph. longitude            :   lambda =  0.0 degr
-    Day of the year at model start :   day_init = 172
-    UTC time at model start        :   time_utc_init = 43200.0 s
     Timestep: dt_radiation =  60.00  s
 
@@ -237,8 +234,11 @@
  -------------------
 
-    Geograph. latitude  :   phi    = 55.0 degr
+    Geograph. latitude  :   latitude  = 55.0 degr
+    Geograph. longitude :   longitude =  0.0 degr
     Angular velocity    :   omega  = 0.729E-04 rad/s
     Coriolis parameter  :   f      =  0.000119 1/s
                             f*     =  0.000084 1/s
+    Day of the year at model start :   day_init = 172
+    UTC time at model start        :   time_utc_init = 43200.0 s
 
     Gravity             :   g      =  9.8 m/s**2
@@ -284,15 +284,15 @@
   0      0 00:00:00.00   8.6700A   5.1898D -0.2288D  0.1182  0.100  0.00   0.200E-11    800.  0.119E+02  0.103E-02  0.611E-03  0.888E-13    9   9  23   11   7  19    5  26   7    0.000    0.000       0
   0      1 00:00:08.67   8.6900A   5.1806   0.2159   0.1162  0.001  0.00   0.000E+00    550.  0.119E+02  0.867E-03  0.287E-05  0.440E-15    9   9  24    4   5  26    5  26   8    0.000    0.000       0
-  0      2 00:00:17.35   8.6900A   5.1762   0.1915   0.1151  0.021  1.11  -0.474E+02    100.  0.119E+02  0.793E-03  0.759E-05  0.407E-15    5  16  32    4   5  27    5  26   9    0.000    0.000       0
-  0      3 00:00:26.04   8.7000A   5.1723   0.1786   0.1113  0.021  0.72  -0.545E+01    100.  0.119E+02  0.751E-03  0.253E-05  0.386E-15    5  16  33    4   5  28    5  26  10    0.000    0.000       0
-  0      4 00:00:34.75   8.7000A   5.1732  -0.1675   0.1061  0.028  0.70  -0.372E+01    100.  0.119E+02  0.721E-03  0.408E-05  0.358E-15    5  16  34    8  29  32    5  26  11    0.000    0.000       0
-  0      5 00:00:43.45   8.7000A   5.1719  -0.1671   0.1028  0.034  0.94  -0.297E+01    250.  0.119E+02  0.698E-03  0.487E-05  0.337E-15    5  16  35    8  29  33    5  26  11    0.000    0.000       0
-  0      6 00:00:52.15   8.7000A   5.1701  -0.1621   0.1039  0.040  0.94  -0.250E+01    250.  0.119E+02  0.680E-03  0.567E-05  0.321E-15    5  16  36    8  29  34    5  26  12    0.000    0.000       0
-  0      7 00:01:00.85   8.7100A   5.1675  -0.1565   0.1043  0.046  1.22  -0.218E+01    550.  0.119E+02  0.665E-03  0.649E-05  0.306E-15    5  16  37    8  29  35    5  26  13    0.000    0.000       0
-  0      8 00:01:09.56   8.7100A   5.1643   0.1515   0.1040  0.051  1.23  -0.195E+01    550.  0.119E+02  0.652E-03  0.733E-05  0.295E-15    5  16  38   11   3  22    5  26  14    0.000    0.000       0
-  0      9 00:01:18.27   8.7100A   5.1636  -0.1506   0.1034  0.057  1.21  -0.172E+01    550.  0.119E+02  0.640E-03  0.812E-05  0.282E-15    5  16  38    8  29  36    5  26  15    0.000    0.000       0
-  0     10 00:01:26.98   8.7100A   5.1636  -0.1516   0.1024  0.062  1.22  -0.158E+01    550.  0.119E+02  0.630E-03  0.898E-05  0.270E-15    5  16  39    8  29  37    5  26  16    0.000    0.000       0
-  0     11 00:01:35.69   8.7200A   5.1632  -0.1516   0.1013  0.067  1.22  -0.148E+01    550.  0.119E+02  0.620E-03  0.980E-05  0.260E-15    5  16   0    8  29  38    5  26  17    0.000    0.000       0
-  0     12 00:01:44.41   8.7200A   5.1625  -0.1506   0.0999  0.072  1.23  -0.139E+01    550.  0.119E+02  0.612E-03  0.106E-04  0.250E-15    5  16   1    8  29  39    5  26  18    0.000    0.000       0
-  0     13 00:01:53.13   8.7200A   5.1614  -0.1488   0.0984  0.077  1.23  -0.132E+01    550.  0.119E+02  0.604E-03  0.115E-04  0.239E-15    5  16   2    8  29   0    5  26  19    0.000    0.000       0
-  0     14 00:02:01.85   8.7200A   5.1600  -0.1462   0.0966  0.082  1.24  -0.126E+01    550.  0.119E+02  0.596E-03  0.123E-04  0.231E-15    5  16   3    8  29   1    5  26  20    0.000    0.000       0
+  0      2 00:00:17.35   8.6900A   5.1762   0.1915   0.1151  0.021  1.06  -0.495E+02    100.  0.119E+02  0.793E-03  0.744E-05  0.407E-15    5  16  32    4   5  27    5  26   9    0.000    0.000       0
+  0      3 00:00:26.04   8.7000A   5.1723   0.1786   0.1113  0.021  0.70  -0.516E+01    100.  0.119E+02  0.751E-03  0.247E-05  0.385E-15    5  16  33    4   5  28    5  26  10    0.000    0.000       0
+  0      4 00:00:34.75   8.7000A   5.1732  -0.1675   0.1061  0.027  0.69  -0.360E+01    100.  0.119E+02  0.721E-03  0.396E-05  0.358E-15    5  16  34    8  29  32    5  26  11    0.000    0.000       0
+  0      5 00:00:43.45   8.7000A   5.1719  -0.1671   0.1028  0.034  0.93  -0.287E+01    250.  0.119E+02  0.698E-03  0.471E-05  0.337E-15    5  16  35    8  29  33    5  26  11    0.000    0.000       0
+  0      6 00:00:52.15   8.7000A   5.1701  -0.1621   0.1039  0.039  0.93  -0.242E+01    250.  0.119E+02  0.680E-03  0.548E-05  0.321E-15    5  16  36    8  29  34    5  26  12    0.000    0.000       0
+  0      7 00:01:00.85   8.7100A   5.1675  -0.1565   0.1043  0.045  1.21  -0.211E+01    550.  0.119E+02  0.665E-03  0.627E-05  0.306E-15    5  16  37    8  29  35    5  26  13    0.000    0.000       0
+  0      8 00:01:09.56   8.7100A   5.1643   0.1515   0.1040  0.051  1.21  -0.189E+01    550.  0.119E+02  0.652E-03  0.709E-05  0.294E-15    5  16  38   11   3  22    5  26  14    0.000    0.000       0
+  0      9 00:01:18.27   8.7100A   5.1636  -0.1506   0.1034  0.056  1.20  -0.166E+01    550.  0.119E+02  0.640E-03  0.785E-05  0.282E-15    5  16  38    8  29  36    5  26  15    0.000    0.000       0
+  0     10 00:01:26.98   8.7100A   5.1635  -0.1516   0.1024  0.061  1.20  -0.153E+01    550.  0.119E+02  0.630E-03  0.868E-05  0.269E-15    5  16  39    8  29  37    5  26  16    0.000    0.000       0
+  0     11 00:01:35.69   8.7200A   5.1632  -0.1516   0.1013  0.067  1.20  -0.143E+01    550.  0.119E+02  0.620E-03  0.949E-05  0.260E-15    5  16   0    8  29  38    5  26  17    0.000    0.000       0
+  0     12 00:01:44.41   8.7200A   5.1624  -0.1506   0.0999  0.072  1.21  -0.135E+01    550.  0.119E+02  0.612E-03  0.103E-04  0.249E-15    5  16   1    8  29  39    5  26  18    0.000    0.000       0
+  0     13 00:01:53.13   8.7200A   5.1614  -0.1488   0.0983  0.077  1.22  -0.128E+01    550.  0.119E+02  0.604E-03  0.111E-04  0.239E-15    5  16   2    8  29   0    5  26  19    0.000    0.000       0
+  0     14 00:02:01.85   8.7200A   5.1600  -0.1462   0.0966  0.081  1.22  -0.122E+01    550.  0.119E+02  0.596E-03  0.119E-04  0.230E-15    5  16   3    8  29   1    5  26  20    0.000    0.000       0