Index: palm/trunk/SCRIPTS/.palm.config.crayh
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.crayh	(revision 2692)
+++ palm/trunk/SCRIPTS/.palm.config.crayh	(revision 2693)
@@ -26,26 +26,27 @@
 %compiler_options    -em -O3 -hnoomp -hnoacc -hfp3 -hdynamic
 %linker_options      -em -O3 -hnoomp -hnoacc -hfp3 -hdynamic -dynamic
-%execute_command     aprun  -n {{MPI_TASKS}}  -N {{TASKS_PER_NODE}}  palm
+%execute_command     aprun  -n {{mpi_tasks}}  -N {{tasks_per_node}}  palm
+%execute_command_for_combine     aprun  -n 1  -N 1  ./combine_plot_fields.x
 %memory              2300
 %module_commands     module load fftw cray-hdf5-parallel cray-netcdf-hdf5parallel
 %login_init_cmd      module switch craype-ivybridge craype-haswell
 #
-# BATCH-directives to be used for batch jobs.
+# BATCH-directives to be used for batch jobs
 BD:#!/bin/bash
-BD:#PBS -A {{PROJECT_ACCOUNT}}
-BD:#PBS -N {{JOB_ID}}
-BD:#PBS -l walltime={{CPU_HOURS}}:{{CPU_MINUTES}}:{{CPU_SECONDS}}
-BD:#PBS -l nodes={{NODES}}:ppn={{TASKS_PER_NODE}}
-BD:#PBS -o {{JOBFILE}}
+BD:#PBS -A {{project_account}}
+BD:#PBS -N {{job_id}}
+BD:#PBS -l walltime={{cpu_hours}}:{{cpu_minutes}}:{{cpu_seconds}}
+BD:#PBS -l nodes={{nodes}}:ppn={{tasks_per_node}}
+BD:#PBS -o {{job_protocol_file}}
 BD:#PBS -j oe
-BD:#PBS -q {{QUEUE}}
+BD:#PBS -q {{queue}}
 #
 # BATCH-directives for batch jobs used to send back the jobfile from a remote to a local host
 BDT:#!/bin/bash
-BDT:#PBS -A {{PROJECT_ACCOUNT}}
+BDT:#PBS -A {{project_account}}
 BDT:#PBS -N job_protocol_transfer
 BDT:#PBS -l walltime=00:30:00
 BDT:#PBS -l nodes=1:ppn=1
-BDT:#PBS -o {{JOB_TRANSFER_PROTOCOL_FILE}}
+BDT:#PBS -o {{job_transfer_protocol_file}}
 BDT:#PBS -j oe
 BDT:#PBS -q dataq
Index: palm/trunk/SCRIPTS/.palm.config.default
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.default	(revision 2692)
+++ palm/trunk/SCRIPTS/.palm.config.default	(revision 2693)
@@ -18,5 +18,5 @@
 %linker_options      -openmp -fpe0 -O3 -xHost -fp-model source -ftz -fno-alias -no-prec-div -no-prec-sqrt -ip -nbs -I /muksoft/packages/fftw/3.3.4/include -L/muksoft/packages/fftw/3.3.4/lib64 -lfftw3 -I /muksoft/packages/netcdf/4_intel/include -L/muksoft/packages/netcdf/4_intel/lib -lnetcdf -lnetcdff
 %hostfile            auto
-%execute_command     mpiexec  -machinefile hostfile  -n {{MPI_TASKS}}  palm
+%execute_command     mpiexec  -machinefile hostfile  -n {{mpi_tasks}}  palm
 #
 #----------------------------------------------------------------------------
Index: palm/trunk/SCRIPTS/.palm.config.default.in
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.default.in	(revision 2692)
+++ palm/trunk/SCRIPTS/.palm.config.default.in	(revision 2693)
@@ -37,5 +37,5 @@
 %compiler_options    @PALM_COMPILER_OPTIONS@
 %linker_options      @PALM_LINKER_OPTIONS@
-%execute_command     mpirun -n {{MPI_TASKS}} ./palm
+%execute_command     mpirun -n {{mpi_tasks}} ./palm
 #%memory              2300
 #%module_commands     module load fftw cray-hdf5-parallel cray-netcdf-hdf5parallel
@@ -45,18 +45,18 @@
 # Directives to be used for batch jobs
 # Lines must start with "BD:". If $-characters are required, hide them with \
-# Internal variables can be used as {{VARIABLE_NAME}}. Please see documentation.
+# Internal variables can be used as {{variable_name}}. Please see documentation.
 #-------------------------------------------------------------------------------
 BD:#!/bin/bash
-BD:#PBS -N {{JOB_ID}}
-BD:#PBS -l walltime={{CPU_HOURS}}:{{CPU_MINUTES}}:{{CPU_SECONDS}}
-BD:#PBS -l nodes={{NODES}}:ppn={{TASKS_PER_NODE}}
-BD:#PBS -o {{JOBFILE}}
+BD:#PBS -N {{job_id}}
+BD:#PBS -l walltime={{cpu_hours}}:{{cpu_minutes}}:{{cpu_seconds}}
+BD:#PBS -l nodes={{nodes}}:ppn={{tasks_per_node}}
+BD:#PBS -o {{job_protocol_file}}
 BD:#PBS -j oe
-BD:#PBS -q {{QUEUE}}
+BD:#PBS -q {{queue}}
 #
 #-------------------------------------------------------------------------------
 # Directives for batch jobs used to send back the jobfiles from a remote to a local host
 # Lines must start with "BDT:". If $-characters are required, excape them with triple backslash
-# Internal variables can be used as {{VARIABLE_NAME}}. Please see documentation.
+# Internal variables can be used as {{variable_name}}. Please see documentation.
 #-------------------------------------------------------------------------------
 BDT:#!/bin/bash
@@ -64,5 +64,5 @@
 BDT:#PBS -l walltime=00:30:00
 BDT:#PBS -l nodes=1:ppn=1
-BDT:#PBS -o {{JOB_TRANSFER_PROTOCOL_FILE}}
+BDT:#PBS -o {{job_transfer_protocol_file}}
 BDT:#PBS -j oe
 BDT:#PBS -q dataq
Index: palm/trunk/SCRIPTS/.palm.config.idefix
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.idefix	(revision 2692)
+++ palm/trunk/SCRIPTS/.palm.config.idefix	(revision 2693)
@@ -29,15 +29,15 @@
 %module_commands     module load intel-compiler/2017.1.132 mvapich2/2.2/intel fftw/3.3.6-pl1/mvapich2-intel hdf5-parallel/1.10.0-patch1/intel netcdf4_hdf5parallel/4411c_443f/intel
 #
-%execute_command     mpirun  -machinefile hostfile  -n {{MPI_TASKS}} palm
+%execute_command     mpirun  -machinefile hostfile  -n {{mpi_tasks}} palm
 #
 #
 # BATCH-directives to be used for batch jobs.
 BD:#!/bin/bash
-BD:#PBS -N{{JOB_ID}}
-BD:#PBS -l walltime={{CPU_HOURS}}:{{CPU_MINUTES}}:{{CPU_SECONDS}}
-BD:#PBS -l ncpus={{CORES}}
-BD:#PBS -o{{JOBFILE}}
+BD:#PBS -N{{job_id}}
+BD:#PBS -l walltime={{cpu_hours}}:{{cpu_minutes}}:{{cpu_seconds}}
+BD:#PBS -l ncpus={{cores}}
+BD:#PBS -o{{job_protocol_file}}
 BD:#PBS -j oe
-BD:#PBS -q{{QUEUE}}
+BD:#PBS -q{{queue}}
 #
 # BATCH-directives for batch jobs used to send back the jobfile from a remote to a local host
@@ -46,5 +46,5 @@
 BDT:#PBS -l walltime=00:30:00
 BDT:#PBS -l ncpus=1
-BDT:#PBS -o{{JOB_TRANSFER_PROTOCOL_FILE}}
+BDT:#PBS -o{{job_transfer_protocol_file}}
 BDT:#PBS -j oe
 BDT:#PBS -q workq
Index: palm/trunk/SCRIPTS/.palm.config.imuk
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.imuk	(revision 2692)
+++ palm/trunk/SCRIPTS/.palm.config.imuk	(revision 2693)
@@ -5,4 +5,5 @@
 %base_data         ~/palm/current_version/JOBS
 %base_directory    $HOME/palm/current_version
+%fast_io_catalog   /localdata/raasch
 %source_path       $HOME/palm/current_version/trunk/SOURCE
 %user_source_path  $base_directory/JOBS/$fname/USER_CODE
@@ -10,5 +11,4 @@
 %local_ip            130.75.105.103
 %local_username      raasch
-%fast_io_catalog     /localdata/raasch
 %compiler_name       mpif90
 %compiler_name_ser   ifort
@@ -18,5 +18,5 @@
 %linker_options      -openmp -fpe0 -O3 -xHost -fp-model source -ftz -fno-alias -no-prec-div -no-prec-sqrt -ip -nbs -I /muksoft/packages/fftw/3.3.4/include -L/muksoft/packages/fftw/3.3.4/lib64 -lfftw3 -I /muksoft/packages/netcdf/4_intel/include -L/muksoft/packages/netcdf/4_intel/lib -lnetcdf -lnetcdff
 %hostfile            auto
-%execute_command     mpiexec  -machinefile hostfile  -n {{MPI_TASKS}}  palm
+%execute_command     mpiexec  -machinefile hostfile  -n {{mpi_tasks}}  palm
 #
 #----------------------------------------------------------------------------
Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 2692)
+++ palm/trunk/SCRIPTS/palmrun	(revision 2693)
@@ -27,4 +27,8 @@
 # -----------------
 # $Id$
+# replacement of variables given by {{<variable>}} in configuration file is now
+# done in a more general way, variable names are written in small letters
+# 
+# 2670 2017-12-06 16:32:19Z raasch
 # test printouts removed
 # 
@@ -2041,6 +2045,6 @@
 
        # REPLACE PARAMETERS IN THE EXECUTION COMMAND WITH REAL VALUES
-    line=`echo  "${execute_command}" | sed 's/{{MPI_TASKS}}/$mpi_tasks/g' | sed 's/{{TASKS_PER_NODE}}/$tasks_per_node/g'`
-    line2=`echo  "${execute_command}" | sed 's/{{MPI_TASKS}}/1/g' | sed 's/{{TASKS_PER_NODE}}/1/g' | sed 's/palm/combine_plot_fields.x/g'`
+    line=`echo  "${execute_command}" | sed 's/{{/$/g' | sed 's/}}//g'`
+    line2=`echo  "${execute_command}" | sed 's/{{mpi_tasks}}/1/g' | sed 's/{{tasks_per_node}}/1/g' | sed 's/palm/combine_plot_fields.x/g'`
     eval line=\"$line\"
     execute_command="$line"
@@ -2700,5 +2704,5 @@
     do
        (( i = i + 1 ))
-       line=`echo  "${batch_directive[$i]}" | sed 's/{{JOB_ID}}/$job_id/g' | sed 's/{{JOBFILE}}/$job_protocol_file/g' | sed 's/{{CPU_HOURS}}/$cpu_hours/g' | sed 's/{{CPU_MINUTES}}/$cpu_minutes/g' | sed 's/{{CPU_SECONDS}}/$cpu_seconds/g' | sed 's/{{NODES}}/$nodes/g' | sed 's/{{CORES}}/$cores/g' | sed 's/{{TASKS_PER_NODE}}/$tasks_per_node/g' | sed 's/{{HOST_CONFIGURATION}}/${host_configuration}/g' | sed 's/{{FNAME}}/$fname/g' | sed 's/{{QUEUE}}/$queue/g' | sed 's/{{MEMORY}}/$memory/g' | sed 's/{{PROJECT_ACCOUNT}}/$project_account/g' | sed 's/{{PREVIOUS_JOB}}/$previous_job/g' | sed 's/{{TEMPDIR}}/$tempdir/g'`
+       line=`echo  "${batch_directive[$i]}" | sed 's/{{/$/g' | sed 's/}}//g'`
        eval line=\"$line\"
        echo  "$line"                               >>  $jobfile
@@ -2722,5 +2726,5 @@
        do
           (( i = i + 1 ))
-          line=`echo  "${batch_directive_transfer[$i]}" | sed 's/{{JOB_ID}}/$job_id/g' | sed 's/{{JOBFILE}}/$job_protocol_file/g' | sed 's/{{JOB_TRANSFER_PROTOCOL_FILE}}/$job_transfer_protocol_file/g' | sed 's/{{CPU_HOURS}}/$cpu_hours/g' | sed 's/{{CPU_MINUTES}}/$cpu_minutes/g' | sed 's/{{CPU_SECONDS}}/$cpu_seconds/g' | sed 's/{{NODES}}/$nodes/g' | sed 's/{{TASKS_PER_NODE}}/$tasks_per_node/g' | sed 's/{{HOST_CONFIGURATION}}/${host_configuration}/g' | sed 's/{{FNAME}}/$fname/g' | sed 's/{{PROJECT_ACCOUNT}}/$project_account/g'`
+          line=`echo  "${batch_directive_transfer[$i]}" | sed 's/{{/$/g' | sed 's/}}//g'`
           eval line=\"$line\"
           echo  "$line"                            >>  $jobfile